-- works

local M={}
function M.sendTS(key, data, call) 
	if (not key) or (not data) then
		print("Lost data")
		return
	end
	
	local send = ""
	local count = 1
	for k, v in pairs(data) do
		send = send .. "&" .. k .. "=" .. v
		count = count + 1
	end

	print(send)
	
	if wifi.sta.status() == 5 then
		local con = net.createConnection(net.TCP, 0)
        con:on("receive", function(con, payload)
            if (string.find(payload, "Status: 200 OK") ~= nil) then
                print("\nPosted.")
            else
				print("Error!")
				print(payload)
			end
        end)
        con:on("connection", function(con, payload)
			con:send(
				"POST /update?api_key=" .. key .. 
				send ..
				" HTTP/1.1\r\n" .. 
				"Host: api.thingspeak.com\r\n" .. 
				"Connection: close\r\n" .. 
				"Accept: */*\r\n" .. 
				"User-Agent: Mozilla/4.0 (compatible; esp8266 Lua; Windows NT 5.1)\r\n" .. 
				"\r\n")
        end)
        con:on("disconnection", function(con, payload)
            con:close();
            print("Disconnected")
            send = nil
            count = nil
            con = nil
            key = nil
            data = nil
            
			if call then call() end
        end)
        -- Connect to Thingspeak
        con:connect(80,'api.thingspeak.com')
    else
        print("Lost WiFi")
    end
end 

return M
